# mysql4 and apache1 seem problematic right now
# mysql5 OK
%def_without apache
%def_with cgi
%def_with mysql
%def_with sensors
%def_disable static

Name: collectd
Version: 3.11.7
Release: alt4

Summary: Statistics collection for filling RRD files
License: GPL
Group: Monitoring

Url: http://collectd.org
Source0: %url/files/%name-%version.tar.bz2
Source1: %name.init
Source2: %name.conf
Source3: %name.htaccess

Patch0: collectd-3.9.0-alt-hddtemp.patch
Patch1: %name-syslog.patch
Patch2: collectd-3.11.7-alt-cgi-tmpfile.patch
Packager: Michael Shigorin <mike@altlinux.org>

Requires: rrdtool

# Automatically added by buildreq on Sun Jan 28 2007 (-bi)
BuildRequires: gcc-c++ libMySQL-devel libcurl-devel libe2fs-devel librrd-devel libsensors-devel libxfs-devel perl-CGI python-modules-compiler python-modules-encodings rrd-perl
BuildRequires: perl-devel

#BuildRequires: linux-libc-headers

%if_with apache
BuildRequires(pre): apache-devel
%endif

%if_with cgi
BuildRequires: perl-CGI 
BuildRequires(pre): apache-devel
%endif

%if_with mysql
BuildRequires: libMySQL-devel 
%endif

%if_with sensors
BuildRequires: libsensors-devel
%endif

%description
collectd is a small program written in C for performance. It reads various
system statistics and updates RRD files, creating them if neccessary.
Since it doesn't need to startup every time it wants to update the files
it's very fast and easy on the system. Also, the statistics are very
fine grained since the files are updated every 10 seconds.

%if_with cgi
%package cgi
Summary: CGI script for collectd
Group: Monitoring
Requires: collectd = %version
Requires: apache-common, perl

%description cgi
This CGI frontend for collectd allows to browse the stats online

Check http://localhost/%name/collection.cgi for collectd views
%endif

%if_with mysql
%package mysql
Summary: MySQL support module for collectd
Group: Monitoring
Requires: collectd = %version
Requires: libMySQL

%description mysql
This plugin for collectd provides querying of MySQL server
%endif

%if_with sensors
%package sensors
Summary: lm_sensors support module for collectd
Group: Monitoring
Requires: collectd = %version
Requires: lm_sensors

%description sensors
This plugin for collectd provides querying of sensors supported
by lm_sensors
%endif

%prep
%setup -q
%patch0 -p1
#patch1
#patch2 -p1 --> better subst below using macro
subst 's/ -Werror//' src/Makefile.*
subst 's,/tmp/collection.log,%_cachedir/httpd/%name/collection.log,' contrib/collection.cgi

%build
CONFFLAGS="--disable-apple_sensors"

%if_without apache
CONFFLAGS="$CONFFLAGS --disable-apache"
%endif

%if_without mysql
CONFFLAGS="$CONFFLAGS --disable-mysql"
%endif

%if_without sensors
CONFFLAGS="$CONFFLAGS --disable-sensors"
%endif

# didn't help
%add_optflags -Wno-unused

# all mainstreams uses localstatedir as var, but ALT set in in /var/lib :(
autoreconf -fisv
%configure $CONFFLAGS %{subst_enable static} --localstatedir=%_var
%make

%install
%make_install DESTDIR=%buildroot install
install -pD -m644 src/collectd.conf %buildroot%_sysconfdir/%name.conf
install -pD -m755 %SOURCE1 %buildroot%_initdir/%name
install -d %buildroot%_libdir/%name/ %buildroot%_localstatedir/%name/
rm -f %buildroot%_libdir/%name/*.la

%if_with cgi
install -d  -m0770 %buildroot%_cachedir/httpd/%name/
install -pD -m0755 contrib/collection.cgi %buildroot%apache_cgibindir/%name/collection.cgi
install -pD -m0644 %SOURCE2 %buildroot%_sysconfdir/httpd/conf/addon-modules.d/%name.conf
install -pD -m0644 %SOURCE3 %buildroot%apache_cgibindir/%name/.htaccess
%endif

%post
%post_service %name

%preun
%preun_service %name

%if_with cgi
%post cgi
%_initdir/httpd condrestart >&/dev/null
%endif

%files
%doc AUTHORS ChangeLog README TODO
%doc contrib/
%config(noreplace) %_sysconfdir/%name.conf
%_initdir/%name
%_sbindir/%name
%_man1dir/*.1*
%_man5dir/*.5*
%dir %_libdir/%name/
%dir %_localstatedir/%name/
%_libdir/%name/*.so*

%if_with sensors
%exclude %_libdir/%name/sensors.so*
%endif

%if_with mysql
%exclude %_libdir/%name/mysql.so*
%endif

%if_with cgi
%files cgi
# FIXME: macroize apache
%attr(0770,root,apache) %dir %_cachedir/httpd/%name/
%dir %apache_cgibindir/%name/
%apache_cgibindir/%name/collection.cgi
%config(noreplace) %apache_cgibindir/%name/.htaccess
%config(noreplace) %_sysconfdir/httpd/conf/addon-modules.d/%name.conf
%endif

%if_with mysql
%files mysql
%_libdir/%name/mysql.so*
%endif

%if_with sensors
%files sensors
%_libdir/%name/sensors.so*
%endif

# TODO:
# - apache.c: figure out what's wrong,
#   supposedly they want apache2
# - consider building with: libcurl, libiokit,
#   liboping (system), libstatgrab (orphaned)
# - better fix for collection.cgi tmpfile

%changelog
* Sun Mar 02 2008 Michael Shigorin <mike@altlinux.org> 3.11.7-alt4
- built against apache-devel again (#14736)

* Sat Jan 12 2008 Michael Shigorin <mike@altlinux.org> 3.11.7-alt3
- silenced cgi %%post (#13945)

* Sun Sep 30 2007 Michael Shigorin <mike@altlinux.org> 3.11.7-alt2
- silly (insufficient) permissions thinko fix
- stupid me, subst thinko fix needed too (patch correct)
- re-upload as new release to override already downloaded
  broken package (CGI wouldn't work at all out-of-box)

* Sun Sep 30 2007 Michael Shigorin <mike@altlinux.org> 3.11.7-alt1
- 3.11.7 (4.0 branch is too unusable for me by now)
  + apcups plugin fixes
- security fix for CGI script: don't use 100%% pre-known
  publicly writable location for temporary file
  (it was an ACL denying writes by apache user to /tmp
  that brought this to light)

* Tue Aug 14 2007 Michael Shigorin <mike@altlinux.org> 4.0.6-alt1
- 4.0.6 (major feature enhancements)
- added apache2-devel, perl-devel to BuildRequires
- enabled apache2 subpackage by default

* Thu May 31 2007 Michael Shigorin <mike@altlinux.org> 3.11.5-alt1
- 3.11.5 (security fixes)
  + fixed buffer overflow in the ntpd plugin
  + fixed support for Linux 2.4 in the disk plugin
  + added large file support (LFS)

* Tue Apr 03 2007 Michael Shigorin <mike@altlinux.org> 3.11.3-alt1
- 3.11.3 (minor bugfixes)

* Sat Feb 10 2007 Michael Shigorin <mike@altlinux.org> 3.11.1-alt1
- 3.11.1 (minor bugfixes)

* Sun Jan 28 2007 Michael Shigorin <mike@altlinux.org> 3.11.0-alt1
- 3.11.0
- removed patch1 (fixed upstream)
- fixed build with recent gcc4.1 (removed -Werror since -Wno-unused
  wouldn't  help)

* Fri Dec 22 2006 Michael Shigorin <mike@altlinux.org> 3.10.3-alt1
- thanks Vitaly Lipatov (lav@) for fixing build (patch sent upstream)
  and other improvements
- service off by default, see also [ru]:
  http://lists.altlinux.org/pipermail/devel/2006-December/039909.html

* Sat Dec 09 2006 Vitaly Lipatov <lav@altlinux.ru> 3.10.3-alt0.2
- NMU: set config as noreplace
- add post/preun service

* Mon Nov 20 2006 Vitaly Lipatov <lav@altlinux.ru> 3.10.3-alt0.1
- NMU: new version 3.10.3
- fix compiling (remove syslog redefine)
- fix default paths in /var (bug #10237)
- move cgi script to cgi/collectd dir
- add .htaccess, collectd.conf for apache

* Sun Sep 17 2006 Michael Shigorin <mike@altlinux.org> 3.10.1-alt2
- accepted spec patch from lakostis@
  + NMU.
  + .spec cleanup.
  + remove unwanted buildrequires.
  + build with system libltdl.
  + build with linux-libc-headers.
  + disable -static builds by default.
- fixed collectd.conf installation (source file moved)

* Sat Aug 05 2006 Michael Shigorin <mike@altlinux.org> 3.10.1-alt1
- 3.10.1

* Sun Jun 18 2006 Michael Shigorin <mike@altlinux.org> 3.9.3-alt1
- 3.9.3 (minor bugfixes)

* Mon May 15 2006 Michael Shigorin <mike@altlinux.org> 3.9.2-alt1
- 3.9.2 (minor bugfixes)
  + ping plugin would stop working after roughly one week
    with default settings

* Fri Apr 28 2006 Michael Shigorin <mike@altlinux.org> 3.9.1-alt1
- 3.9.1

* Sun Apr 23 2006 Michael Shigorin <mike@altlinux.org> 3.9.0-alt2
- macro control over modules (subpackages) built:
  apache, cgi, mysql, sensors (the rest is in the main package)

* Fri Apr 21 2006 Michael Shigorin <mike@altlinux.org> 3.9.0-alt1
- 3.9.0
- updated buildrequires for new plugins
- added mysql subpackage
- added cgi subpackage (WARNING: unrestricted out-of-box)
- patched hddtemp module regarding higher SCSI majors
- disabled apache support for the time being
- disabled apple sensors
- remove (unpackaged) *.la too

* Fri Apr 07 2006 Michael Shigorin <mike@altlinux.org> 3.8.3-alt1
- 3.8.3

* Wed Mar 15 2006 Michael Shigorin <mike@altlinux.org> 3.8.2-alt1
- 3.8.2
- built for Sisyphus
- sample configuration file taken from contrib/ now
  *and* moved to %_sysconfdir/%name.conf [3.8.1-1 spec]
- I've not got around to make this all work more out-of-box, spec fixes
  are welcome but maybe it's better as is (setup isn't that hard)

* Wed Mar 15 2006 Michael Shigorin <mike@altlinux.org> 3.8.0-alt1
- 3.8.0

* Tue Jan 31 2006 Michael Shigorin <mike@altlinux.org> 3.7.0-alt0.M24.1
- 3.7.0

* Mon Dec 19 2005 Michael Shigorin <mike@altlinux.org> 3.5.1-alt0.M24.1
- 3.5.1
- spec cleanup

* Mon Dec 05 2005 Michael Shigorin <mike@altlinux.org> 3.4.0-alt0.M24.1
- 3.4.0

* Wed Nov 09 2005 Michael Shigorin <mike@altlinux.org> 3.3.0-alt0.M24.1
- 3.3.0

* Thu Oct 27 2005 Michael Shigorin <mike@altlinux.org> 3.2.0-alt0.M24.1
- 3.2.0

* Mon Oct 17 2005 Michael Shigorin <mike@altlinux.org> 3.1.0-alt0.M24.1
- built for ALT Linux Master 2.4
- spec cleanup

* Fri Sep 30 2005 Florian octo Forster <octo@verplant.org> 3.0.0-1
- New upstream version
- Split the package into `collectd' and `collectd-sensors'

* Fri Sep 16 2005 Florian octo Forster <octo@verplant.org> 2.1.0-1
- New upstream version

* Mon Sep 10 2005 Florian octo Forster <octo@verplant.org> 2.0.0-1
- New upstream version

* Mon Aug 29 2005 Florian octo Forster <octo@verplant.org> 1.8.0-1
- New upstream version

* Sun Aug 25 2005 Florian octo Forster <octo@verplant.org> 1.7.0-1
- New upstream version

* Sun Aug 21 2005 Florian octo Forster <octo@verplant.org> 1.6.0-1
- New upstream version

* Sun Jul 17 2005 Florian octo Forster <octo@verplant.org> 1.5.1-1
- New upstream version

* Sun Jul 17 2005 Florian octo Forster <octo@verplant.org> 1.5-1
- New upstream version

* Mon Jul 11 2005 Florian octo Forster <octo@verplant.org> 1.4.2-1
- New upstream version

* Sat Jul 09 2005 Florian octo Forster <octo@verplant.org> 1.4-1
- Built on RedHat 7.3
